package pc.feqhiat;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.GridView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import pc.feqhiat.adapter.ItemAdapter;
import pc.feqhiat.adapter.ListAdapter;
import pc.feqhiat.db.DBH_Main;
import pc.feqhiat.model.MainVO;
import pc.feqhiat.utils.ApplicationConstant;
import pc.feqhiat.utils.HTTPServiceHelper;
import pc.feqhiat.utils.Utils;

public class BookMenu extends AppCompatActivity {
    BookMenu act;
    private int item_id = 0;
    //private TextView tvItmName;
    //private ListView listBook;
    private ArrayList<MainVO> al_bookList;
    Toolbar toolbar;
    DBH_Main dbh_mainMenu;
    boolean isNetConnected = false;
    //ListAdapter adapterBook;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_book_menu);
        act = this;
        //listBook = (ListView) findViewById(R.id.list_book);
        //tvItmName = (TextView) findViewById(R.id.tv_itmID);
        al_bookList = new ArrayList<MainVO>();
        dbh_mainMenu = new DBH_Main(act);
        al_bookList = dbh_mainMenu.getAllBooks();

        Bundle extras = getIntent().getExtras();
        if (extras != null) {
            //parent_id = extras.getInt("parent_id");
            item_id = extras.getInt("item_id");
        }

        toolbar = (Toolbar) findViewById(R.id.toolbar);
        toolbar.setTitle("الكتب");
        setSupportActionBar(toolbar);

        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setHomeButtonEnabled(true);
        getSupportActionBar().setDisplayShowHomeEnabled(true);

        isNetConnected = Utils.checkInternetConnection(act);
        if(isNetConnected)
        {
            CountAsyncTask countAsyncTask = new CountAsyncTask();
            countAsyncTask.execute();
        }
        else
        {
            viewGrid();
        }

    }

    /**
     * On selecting action bar icons
     * */
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Take appropriate action for each action item click
        Intent i;
        switch (item.getItemId()) {
            case android.R.id.home:
                onBackPressed();
                return true;
            case R.id.action_home:
                i = new Intent(BookMenu.this, MainActivity.class);
                startActivity(i);
                return true;
            case R.id.action_settings:
                i = new Intent(BookMenu.this, SettingsActivity.class);
                startActivity(i);
                return true;
            case R.id.action_search:
                i = new Intent(BookMenu.this, SearchActivity.class);
                startActivity(i);
                return true;
            case R.id.action_about:
                i = new Intent(BookMenu.this, AboutActivity.class);
                startActivity(i);
                return true;
            case R.id.action_latest:
                i = new Intent(BookMenu.this, ProblemsList.class);
                Bundle extras = new Bundle();
                extras.putString("latest", "true");
                i.putExtras(extras);
                startActivity(i);
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.main_menu, menu);
        return super.onCreateOptionsMenu(menu);
    }


    private class CountAsyncTask extends AsyncTask<Void, Void, Void> {

        Context context;
        ProgressDialog pDialog;
        MainVO mainVO;

        public void Sign_up(Context context) {
            // TODO Auto-generated constructor stub
            this.context = context;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            pDialog = new ProgressDialog(act);
            pDialog.setMessage("الرجاء الانتظار .....");
            pDialog.setCancelable(false);
            pDialog.show();
        }

        @Override
        protected Void doInBackground(Void... arg0) {
            //// Count /////////
            HTTPServiceHelper handler = new HTTPServiceHelper();
            //al_param = new ArrayList<MainVO>();
            HashMap input = new HashMap<>();
            String url = ApplicationConstant.getBooksCount + "&item_id="+item_id;
            String jsonstr = handler.performPostCall(url, input);
            try {
                JSONObject all_jo_str = new JSONObject(jsonstr);
                JSONObject data_jo_str = all_jo_str.getJSONObject("data");

                JSONArray param_jo = data_jo_str.getJSONArray("book_count");
                ///////// COUNTS //////////////////////////////
                for (int i = 0; i < param_jo.length(); i++) {
                    JSONObject param_jo_obj = param_jo.getJSONObject(i);
                    for (int y = 0; y < al_bookList.size(); y++) {
                        mainVO = al_bookList.get(y);
                        if (mainVO.getBookID() == param_jo_obj.getInt("book_id")) {
                            mainVO.setCount(param_jo_obj.getInt("count"));
                            break;
                        }
                    }


                }
            } catch (Exception ex) {
            }

            return null;
        }

        @Override
        protected void onPostExecute(Void result) {
            super.onPostExecute(result);

            pDialog.dismiss();
            viewGrid();

        }
    }

    private void viewGrid()
    {
        GridView gridview = (GridView) findViewById(R.id.gridview);
        gridview.setAdapter(new ItemAdapter(act, "book", al_bookList));

        gridview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            public void onItemClick(AdapterView<?> parent, View v,
                                    int position, long id) {
                MainVO tempValues = (MainVO) al_bookList.get(position);
                Intent i;
                int book_id = tempValues.getBookID();
                i = new Intent(act, ChapterMenu.class);
                Bundle extras = new Bundle();
                extras.putInt("item_id", item_id);
                extras.putInt("book_id", book_id);
                i.putExtras(extras);
                startActivity(i);
            }
        });
    }

}
