package pc.feqhiat;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.GridView;
import android.widget.ListView;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;

import pc.feqhiat.adapter.ListAdapter;
import pc.feqhiat.db.DBH_Main;
import pc.feqhiat.model.MainVO;
import pc.feqhiat.utils.ApplicationConstant;
import pc.feqhiat.utils.HTTPServiceHelper;
import pc.feqhiat.utils.Utils;

public class ChapterMenu extends AppCompatActivity {
    ChapterMenu act;
    private int item_id, book_id = 0;
    private ListView listChapter;
    private ArrayList<MainVO> al_chapterList;
    DBH_Main dbh_mainMenu;
    ListAdapter adapterChapter;
    Toolbar toolbar;
    boolean isNetConnected = false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_chapter_menu);
        act = this;
        toolbar = (Toolbar) findViewById(R.id.toolbar);
        toolbar.setTitle("الأبواب");
        setSupportActionBar(toolbar);

        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setHomeButtonEnabled(true);
        getSupportActionBar().setDisplayShowHomeEnabled(true);

        listChapter = (ListView) findViewById(R.id.list_chapter);

        Bundle extras = getIntent().getExtras();
        if (extras != null) {
            item_id = extras.getInt("item_id");
            book_id = extras.getInt("book_id");
        }
        al_chapterList = new ArrayList<MainVO>();
        dbh_mainMenu = new DBH_Main(act);
        al_chapterList = dbh_mainMenu.getBookChapters(String.valueOf(book_id));

        isNetConnected = Utils.checkInternetConnection(act);
        if(isNetConnected)
        {
            CountAsyncTask countAsyncTask = new CountAsyncTask();
            countAsyncTask.execute();
        }
        else
        {
            viewList();
        }
    }

    private void viewList()
    {
        adapterChapter = new ListAdapter(act, al_chapterList, "chapter");
        // Assign adapter to ListView
        listChapter.setAdapter(adapterChapter);
    }

    //public int getParent_id(){return parent_id;}

    /*****************  This function used by adapter ****************/
    public void onItemClick(int mPosition)
    {
        MainVO tempValues = (MainVO) al_chapterList.get(mPosition);
        Intent i;
        int chapter_id = tempValues.getChapterID();
        i = new Intent(act, ProblemsList.class);
        Bundle extras = new Bundle();
        extras.putInt("item_id", item_id);
        extras.putInt("book_id", book_id);
        extras.putInt("chapter_id", chapter_id);
        i.putExtras(extras);
        startActivity(i);
    }

    /**
     * On selecting action bar icons
     * */
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Take appropriate action for each action item click
        Intent i;
        switch (item.getItemId()) {
            case android.R.id.home:
                onBackPressed();
                return true;
            case R.id.action_home:
                i = new Intent(ChapterMenu.this, MainActivity.class);
                startActivity(i);
                return true;
            case R.id.action_settings:
                i = new Intent(ChapterMenu.this, SettingsActivity.class);
                startActivity(i);
                return true;
            case R.id.action_search:
                i = new Intent(ChapterMenu.this, SearchActivity.class);
                startActivity(i);
                return true;
            case R.id.action_about:
                i = new Intent(ChapterMenu.this, AboutActivity.class);
                startActivity(i);
                return true;
            case R.id.action_latest:
                i = new Intent(ChapterMenu.this, ProblemsList.class);
                Bundle extras = new Bundle();
                extras.putString("latest", "true");
                i.putExtras(extras);
                startActivity(i);
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.main_menu, menu);
        return super.onCreateOptionsMenu(menu);
    }

    private class CountAsyncTask extends AsyncTask<Void, Void, Void> {

        Context context;
        ProgressDialog pDialog;
        MainVO mainVO;

        public void Sign_up(Context context) {
            // TODO Auto-generated constructor stub
            this.context = context;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            pDialog = new ProgressDialog(act);
            pDialog.setMessage("الرجاء الانتظار .....");
            pDialog.setCancelable(false);
            pDialog.show();
        }

        @Override
        protected Void doInBackground(Void... arg0) {
            //// Count /////////
            HTTPServiceHelper handler = new HTTPServiceHelper();
            //al_param = new ArrayList<MainVO>();
            HashMap input = new HashMap<>();
            String url = ApplicationConstant.getChaptersCount + "&book_id="+book_id;
            String jsonstr = handler.performPostCall(url, input);
            try {
                JSONObject all_jo_str = new JSONObject(jsonstr);
                JSONObject data_jo_str = all_jo_str.getJSONObject("data");

                JSONArray param_jo = data_jo_str.getJSONArray("chapter_count");
                ///////// COUNTS //////////////////////////////
                for (int i = 0; i < param_jo.length(); i++) {
                    JSONObject param_jo_obj = param_jo.getJSONObject(i);
                    for (int y = 0; y < al_chapterList.size(); y++) {
                        mainVO = al_chapterList.get(y);
                        if (mainVO.getChapterID() == param_jo_obj.getInt("chapter_id")) {
                            mainVO.setCount(param_jo_obj.getInt("count"));
                            break;
                        }
                    }


                }
            } catch (Exception ex) {
            }

            return null;
        }

        @Override
        protected void onPostExecute(Void result) {
            super.onPostExecute(result);

            pDialog.dismiss();
            viewList();

        }
    }
}
