package pc.feqhiat;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.GridView;
import android.widget.ImageView;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;

import pc.feqhiat.adapter.ItemAdapter;
import pc.feqhiat.db.DBH_Main;
import pc.feqhiat.model.MainVO;
import pc.feqhiat.utils.ApplicationConstant;
import pc.feqhiat.utils.HTTPServiceHelper;
import pc.feqhiat.utils.Utils;

public class MainActivity extends AppCompatActivity {

    private Boolean isNetConnected;

    //    ImageLoader imageLoader;
//    DisplayImageOptions options;
    ImageView mainimg;
    MainActivity act;
    DBH_Main dbh_main;
    Toolbar toolbar;
    public ArrayList<MainVO> al_param;
    //private int app_version;
    public ArrayList<MainVO> al_itemList;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        act = this;

        // action bar
        initToolBar("الرئيسية");
        /////////////////
        // initialize the server version to local version, to make it work if it is offline
        //server_version = ApplicationConstant.app_version;


        al_itemList = new ArrayList<MainVO>();
        dbh_main = new DBH_Main(act);
        isNetConnected = Utils.checkInternetConnection(act);
        if(isNetConnected)
        {
            ParamAsyncTask paramasynctask = new ParamAsyncTask();
            paramasynctask.execute();
        }
        else
        {
            viewGrid();
        }
    }

    public void initToolBar(String toolbarTitle) {
        toolbar = (Toolbar) findViewById(R.id.toolbar);
        toolbar.setTitle(toolbarTitle);
        setSupportActionBar(toolbar);
    }

    /**
     * On selecting action bar icons
     * */
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Take appropriate action for each action item click
        Intent i;
        switch (item.getItemId()) {
//            case R.id.action_home:
//                i = new Intent(MainActivity.this, MainActivity.class);
//                startActivity(i);
//                return true;
            case R.id.action_settings:
                i = new Intent(MainActivity.this, SettingsActivity.class);
                startActivity(i);
                return true;
            case R.id.action_search:
                i = new Intent(MainActivity.this, SearchActivity.class);
                startActivity(i);
                return true;
            case R.id.action_about:
                i = new Intent(MainActivity.this, AboutActivity.class);
                startActivity(i);
                return true;
            case R.id.action_latest:
                i = new Intent(MainActivity.this, ProblemsList.class);
                Bundle extras = new Bundle();
                extras.putString("latest", "true");
                i.putExtras(extras);
                startActivity(i);
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.main_menu, menu);
        return super.onCreateOptionsMenu(menu);
    }

    public class ParamAsyncTask extends AsyncTask<Void, Void, Void> {

        Context context;
        ProgressDialog pDialog;
        MainVO mainVO;

        public void Sign_up(Context context) {
            // TODO Auto-generated constructor stub
            this.context = context;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            pDialog = new ProgressDialog(act);
            pDialog.setMessage("الرجاء الانتظار .....");
            pDialog.setCancelable(false);
            pDialog.show();
        }

        @Override
        protected Void doInBackground(Void... arg0) {
            //// Param /////////
            HTTPServiceHelper handler = new HTTPServiceHelper();
            al_param = new ArrayList<MainVO>();
            HashMap input = new HashMap<>();
            String jsonstr = handler.performPostCall(ApplicationConstant.param_url, input);
            try {
                JSONObject all_jo_str = new JSONObject(jsonstr);
                JSONObject data_jo_str = all_jo_str.getJSONObject("data");

                JSONArray param_jo = data_jo_str.getJSONArray("params");
                ///////// PARAMS //////////////////////////////
                for (int i = 0; i < param_jo.length(); i++) {
                    JSONObject param_jo_obj = param_jo.getJSONObject(i);

                    mainVO = new MainVO();
                    mainVO.setParamID(param_jo_obj.getInt("param_id"));
                    mainVO.setDesc(param_jo_obj.getString("name"));
                    mainVO.setParamValue(param_jo_obj.getString("value"));
                    mainVO.setUpdate_time(param_jo_obj.getInt("update_time"));

                    al_param.add(mainVO);
                }
            } catch (Exception ex) {}

            return null;
        }

        @Override
        protected void onPostExecute(Void result) {
            super.onPostExecute(result);

            pDialog.dismiss();
            /// Check if server version is different than local version, request for update
            if(!(getParamByName("app_version", al_param).getParamValue().equals("")) && !(ApplicationConstant.app_version.equals(getParamByName("app_version", al_param).getParamValue())))
            {
                    Intent i = new Intent(MainActivity.this, WarningActivity.class);
                    finish();
                    startActivity(i);
            }
            else
            {
                // if the DB local version == DB Server Version => load local data
                if(dbh_main.getParamByName("db_version").getParamValue().equals(getParamByName("db_version", al_param).getParamValue()))
                {
                    getCount();
                }
                else // there are some changes in server DB
                {
                    ItemlistAsyncTask itemlistasynctask = new ItemlistAsyncTask();
                    itemlistasynctask.execute();
                }
            }


        }
    }

    public class ItemlistAsyncTask extends AsyncTask<Void, Void, Void> {

        Context context;
        private String item_name, item_icon;
        private int item_id, update_time;
        ProgressDialog pDialog;
        MainVO mainVO;

        public void Sign_up(Context context) {
            // TODO Auto-generated constructor stub
            this.context = context;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            pDialog = new ProgressDialog(act);
            pDialog.setMessage("الرجاء الانتظار .....");
            pDialog.setCancelable(false);
            pDialog.show();
        }

        @Override
        protected Void doInBackground(Void... arg0) {
            //// Items /////////
            HTTPServiceHelper handler = new HTTPServiceHelper();
            HashMap input = new HashMap<>();
            String jsonstr = handler.performPostCall(ApplicationConstant.all_data, input);
            try {
                JSONObject all_jo_str = new JSONObject(jsonstr);
                JSONObject data_jo_str = all_jo_str.getJSONObject("data");

                JSONArray item_jo = data_jo_str.getJSONArray("items");
                JSONArray book_jo = data_jo_str.getJSONArray("books");
                JSONArray chapter_jo = data_jo_str.getJSONArray("chapters");
                JSONArray faqih_jo = data_jo_str.getJSONArray("faqih");
                //server_version = data_jo_str.getInt("server_version");
                ///////// ITEMS //////////////////////////////
                if(item_jo.length() > 0)
                    dbh_main.deleteAllItems();
                for (int i = 0; i < item_jo.length(); i++) {
                    JSONObject item_jo_obj = item_jo.getJSONObject(i);
                    item_id = item_jo_obj.getInt("item_id");
                    item_name = item_jo_obj.getString("item_name");
                    item_icon = item_jo_obj.getString("item_icon");
                    update_time = item_jo_obj.getInt("update_time");

                    mainVO = new MainVO();
                    mainVO.setItemID(item_id);
                    mainVO.setDesc(item_name);
                    mainVO.setFilePath(item_icon);
                    mainVO.setUpdate_time(update_time);

                    dbh_main.insert_item(mainVO);
                }
                al_itemList = dbh_main.getAllItems();
                ///////// BOOKS //////////////////////////////
                if(book_jo.length() > 0)
                    dbh_main.deleteAllBooks();
                for (int i = 0; i < book_jo.length(); i++) {
                    JSONObject book_jo_obj = book_jo.getJSONObject(i);
                    mainVO = new MainVO();
                    mainVO.setBookID(book_jo_obj.getInt("book_id"));
                    mainVO.setDesc(book_jo_obj.getString("book_name"));
                    mainVO.setFilePath(book_jo_obj.getString("book_icon"));
                    mainVO.setUpdate_time(book_jo_obj.getInt("update_time"));
                    dbh_main.insert_book(mainVO);
                }
                ///////// CHAPTERS //////////////////////////////
                if(chapter_jo.length() > 0)
                    dbh_main.deleteAllChapters();
                for (int i = 0; i < chapter_jo.length(); i++) {
                    JSONObject chapter_jo_obj = chapter_jo.getJSONObject(i);

                    mainVO = new MainVO();
                    mainVO.setChapterID(chapter_jo_obj.getInt("chapter_id"));
                    mainVO.setBookID(chapter_jo_obj.getInt("book_id"));
                    mainVO.setDesc(chapter_jo_obj.getString("chapter_name"));
                    mainVO.setFilePath(chapter_jo_obj.getString("chapter_icon"));
                    mainVO.setUpdate_time(chapter_jo_obj.getInt("update_time"));

                    dbh_main.insert_chapter(mainVO);
                }
                ///////// FAQIH //////////////////////////////
                if(faqih_jo.length() > 0)
                    dbh_main.deleteAllFaqih();
                for (int i = 0; i < faqih_jo.length(); i++) {
                    JSONObject faqih_jo_obj = faqih_jo.getJSONObject(i);

                    mainVO = new MainVO();
                    mainVO.setFaqihID(faqih_jo_obj.getInt("faqih_id"));
                    mainVO.setDesc(faqih_jo_obj.getString("faqih_name"));
                    mainVO.setFilePath(faqih_jo_obj.getString("faqih_icon"));
                    mainVO.setUpdate_time(faqih_jo_obj.getInt("update_time"));

                    dbh_main.insert_faqih(mainVO);
                }
            } catch (Exception ex) {}

            return null;
        }

        @Override
        protected void onPostExecute(Void result) {
            super.onPostExecute(result);
            dbh_main.deleteAllParam();
            for (int i=0; i<al_param.size();i++)
            {
                MainVO mv = al_param.get(i);
                dbh_main.insert_param(mv);
            }

            pDialog.dismiss();

            getCount();
            //}

        }
    }

    private class CountAsyncTask extends AsyncTask<Void, Void, Void> {

        Context context;
        ProgressDialog pDialog;
        MainVO mainVO;

        public void Sign_up(Context context) {
            // TODO Auto-generated constructor stub
            this.context = context;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            pDialog = new ProgressDialog(act);
            pDialog.setMessage("الرجاء الانتظار .....");
            pDialog.setCancelable(false);
            pDialog.show();
        }

        @Override
        protected Void doInBackground(Void... arg0) {
            //// Count /////////
            HTTPServiceHelper handler = new HTTPServiceHelper();
            //al_param = new ArrayList<MainVO>();
            HashMap input = new HashMap<>();
            String jsonstr = handler.performPostCall(ApplicationConstant.getItemsCount, input);
            try {
                JSONObject all_jo_str = new JSONObject(jsonstr);
                JSONObject data_jo_str = all_jo_str.getJSONObject("data");

                JSONArray param_jo = data_jo_str.getJSONArray("item_count");
                ///////// COUNTS //////////////////////////////
                for (int i = 0; i < param_jo.length(); i++) {
                    JSONObject param_jo_obj = param_jo.getJSONObject(i);
                    for (int y=0; y < al_itemList.size(); y++)
                    {
                        mainVO = al_itemList.get(y);
                        if(mainVO.getItemID() == param_jo_obj.getInt("item_id"))
                        {
                            mainVO.setCount(param_jo_obj.getInt("count"));
                            break;
                        }
                    }


                }
            } catch (Exception ex) {}

            return null;
        }

        @Override
        protected void onPostExecute(Void result) {
            super.onPostExecute(result);

            pDialog.dismiss();

            viewGrid();
        }
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
        System.exit(0);
    }

    private MainVO getParamByName(String name, ArrayList<MainVO> param)
    {
        //String value = "";
        for (int i=0; i<param.size();i++)
        {
            if(param.get(i).getDesc().equals(name))
            {
                //value = param.get(i).getParamValue();
                return param.get(i);
            }
        }

        return new MainVO();
    }

    private void navigateToView(AdapterView<?> parent, View v, int position, long id)
    {
        Intent i;
        MainVO tempValues = (MainVO) al_itemList.get(position);
        int item_id = tempValues.getItemID(); // to get the parent id , it would be the clicked posion index + 1 in which index starts with 0
        if(item_id == 1) // it means that to send Estfeta أرسل استفتاء
            i = new Intent(act, SendFatwaAct.class);
        else if(item_id == 5) // it means that it is news
            i = new Intent(act, NewsListActivity.class);
        else
            i = new Intent(act, BookMenu.class);
        Bundle extras = new Bundle();
        extras.putInt("item_id", item_id);
        i.putExtras(extras);
        startActivity(i);
    }

    private void getCount()
    {
        al_itemList = dbh_main.getAllItems();
        CountAsyncTask countAsyncTask = new CountAsyncTask();
        countAsyncTask.execute();
    }

    private void viewGrid()
    {
        GridView gridview = (GridView) findViewById(R.id.gridview);
        gridview.setAdapter(new ItemAdapter(act, "item", al_itemList));

        gridview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            public void onItemClick(AdapterView<?> parent, View v,
                                    int position, long id) {
                navigateToView(parent, v, position, id);

            }
        });

    }

}
