package pc.feqhiat;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.ListView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;

import pc.feqhiat.adapter.ListAdapter;
import pc.feqhiat.model.ProblemVO;
import pc.feqhiat.utils.ApplicationConstant;
import pc.feqhiat.utils.HTTPServiceHelper;
import pc.feqhiat.utils.Utils;

public class NewsListActivity extends AppCompatActivity {
    NewsListActivity act;
//    private int item_id, book_id, chapter_id, faqih_id = 0;
//    private String search_text="";
//    private boolean is_search = false;
//    private int count = 20;
//    private int startIndex = 0;
//    Button btnLoadExtra;

//    private String latest = "";
//    private int AllCount = 0;
    private ListView listNews;
    private ArrayList<ProblemVO> al_NewsList;
    //DBH_Main dbh_main;
    ListAdapter adapterNews;
    private Boolean isNetConnected;
    Toolbar toolbar;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_news_list);
        act = this;
        toolbar = (Toolbar) findViewById(R.id.toolbar);
        toolbar.setTitle("الأخبار");
        setSupportActionBar(toolbar);

        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setHomeButtonEnabled(true);
        getSupportActionBar().setDisplayShowHomeEnabled(true);

        listNews = (ListView) findViewById(R.id.list_news);

        al_NewsList = new ArrayList<ProblemVO>();
        //dbh_main = new DBH_Main(act);
        isNetConnected = Utils.checkInternetConnection(act);
        if(isNetConnected)
        {
            NewsListAsyncTask newsListAsyncTask = new NewsListAsyncTask();
            newsListAsyncTask.execute();
        }
        else
        {
            Toast.makeText(act, "أنت غير متصل بالشبكة ...", Toast.LENGTH_LONG).show();
        }
    }

    public class NewsListAsyncTask extends AsyncTask<Void, Void, Void> {

        Context context;

        ProgressDialog pDialog;
        ProblemVO problemVO;

        public void Sign_up(Context context) {
            // TODO Auto-generated constructor stub
            this.context = context;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            pDialog = new ProgressDialog(act);
            pDialog.setMessage("الرجاء الانتظار .....");
            pDialog.setCancelable(false);
            pDialog.show();
        }

        @Override
        protected Void doInBackground(Void... arg0) {
            //// Problems /////////
            HashMap<String, String> problem_input = new HashMap<String, String>();

            String url = "";
            HTTPServiceHelper book_handler = new HTTPServiceHelper();
            url = ApplicationConstant.newsList ;
            String problem_jsonstr = book_handler.performPostCall(url, problem_input);

            ///////// BOOKS //////////////////////////////
            try {
                JSONObject all_jo_str = new JSONObject(problem_jsonstr);
                JSONObject data_jo_str = all_jo_str.getJSONObject("data");

                JSONArray news_jo = data_jo_str.getJSONArray("news");
                ///////// PARAMS //////////////////////////////
                for (int i = 0; i < news_jo.length(); i++) {
                    JSONObject news_jo_obj = news_jo.getJSONObject(i);

                    problemVO = new ProblemVO();
                    problemVO.setNewsID(news_jo_obj.getInt("news_id"));
                    problemVO.setNewsTitle(news_jo_obj.getString("title"));
                    problemVO.setNewsSummary(news_jo_obj.getString("summary"));
                    problemVO.setNewsContent(news_jo_obj.getString("content"));
                    problemVO.setUpdate_time(news_jo_obj.getInt("update_time"));

                    al_NewsList.add(problemVO);
                }

            } catch (Exception ex) {}

            return null;
        }

        @Override
        protected void onPostExecute(Void result) {
            super.onPostExecute(result);

            pDialog.dismiss();
            // Assign adapter to ListView
            adapterNews = new ListAdapter(act, al_NewsList, "news");
            listNews.setAdapter(adapterNews);
        }
    }

    /*****************  This function used by adapter ****************/
    public void onItemClick(int position)
    {
        ProblemVO tempValues = (ProblemVO) al_NewsList.get(position);
        Intent i;
        //int news_id = tempValues.getNewsID();
        //String problem_text = tempValues.getProblemText();
        i = new Intent(act, NewsActivity.class);
        Bundle extras = new Bundle();
        extras.putInt("news_id", tempValues.getNewsID());
        extras.putString("title", tempValues.getNewsTitle());
        extras.putString("content", tempValues.getNewsContent());
        i.putExtras(extras);
        startActivity(i);
    }

    /**
     * On selecting action bar icons
     * */
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Take appropriate action for each action item click
        Intent i;
        switch (item.getItemId()) {
            case android.R.id.home:
                onBackPressed();
                return true;
            case R.id.action_home:
                i = new Intent(NewsListActivity.this, MainActivity.class);
                startActivity(i);
                return true;
            case R.id.action_settings:
                i = new Intent(NewsListActivity.this, SettingsActivity.class);
                startActivity(i);
                return true;
            case R.id.action_search:
                i = new Intent(NewsListActivity.this, SearchActivity.class);
                startActivity(i);
                return true;
            case R.id.action_about:
                i = new Intent(NewsListActivity.this, AboutActivity.class);
                startActivity(i);
                return true;
            case R.id.action_latest:
                i = new Intent(NewsListActivity.this, ProblemsList.class);
                Bundle extras = new Bundle();
                extras.putString("latest", "true");
                i.putExtras(extras);
                startActivity(i);
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.main_menu, menu);
        return super.onCreateOptionsMenu(menu);
    }
}
