package pc.feqhiat;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.GridView;
import android.widget.ListView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;

import pc.feqhiat.adapter.ItemAdapter;
import pc.feqhiat.adapter.ListAdapter;
import pc.feqhiat.db.DBH_Main;
import pc.feqhiat.model.MainVO;
import pc.feqhiat.model.ProblemVO;
import pc.feqhiat.utils.ApplicationConstant;
import pc.feqhiat.utils.HTTPServiceHelper;
import pc.feqhiat.utils.Utils;

public class ProblemsList extends AppCompatActivity {

    ProblemsList act;
    private int item_id, book_id, chapter_id, faqih_id = 0;
    private String search_text="";
    private boolean is_search = false;
    private int count = 20;
    private int startIndex = 0;
    Button btnLoadExtra;

    private String latest = "";
    private int AllCount = 0;
    private ListView listProblems;
    private ArrayList<ProblemVO> al_problemsList;
    //DBH_Main dbh_main;
    ListAdapter adapterProblem;
    private Boolean isNetConnected;
    Toolbar toolbar;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_problems_list);
        act = this;
        toolbar = (Toolbar) findViewById(R.id.toolbar);
        toolbar.setTitle("المسائل");
        setSupportActionBar(toolbar);

        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setHomeButtonEnabled(true);
        getSupportActionBar().setDisplayShowHomeEnabled(true);

        listProblems = (ListView) findViewById(R.id.list_problem);

        Bundle extras = getIntent().getExtras();
        if (extras != null) {
            item_id = extras.getInt("item_id", 0);
            book_id = extras.getInt("book_id", 0);
            chapter_id = extras.getInt("chapter_id", 0);
            faqih_id = extras.getInt("faqih_id", 0);
            search_text = extras.getString("search_text", "");
            latest = extras.getString("latest", "");
            is_search = extras.getBoolean("is_search", false);

        }
        al_problemsList = new ArrayList<ProblemVO>();
        //dbh_main = new DBH_Main(act);
        isNetConnected = Utils.checkInternetConnection(act);
        if(isNetConnected)
        {
            ProblemListAsyncTask problemListAsyncTask = new ProblemListAsyncTask();
            problemListAsyncTask.execute();
        }
        else
        {
            Toast.makeText(act, "أنت غير متصل بالشبكة ...", Toast.LENGTH_LONG).show();
        }
    }

    public class ProblemListAsyncTask extends AsyncTask<Void, Void, Void> {

        Context context;
        //private String item_name, item_icon;
        //private int item_id, update_time;
        ProgressDialog pDialog;
        ProblemVO problemVO;

        public void Sign_up(Context context) {
            // TODO Auto-generated constructor stub
            this.context = context;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            pDialog = new ProgressDialog(act);
            pDialog.setMessage("الرجاء الانتظار .....");
            pDialog.setCancelable(false);
            pDialog.show();
        }

        @Override
        protected Void doInBackground(Void... arg0) {
            //// Problems /////////
            HashMap<String, String> problem_input = new HashMap<String, String>();
            if(is_search)
            {
                problem_input.put("problem", search_text);
                problem_input.put("faqih_id", String.valueOf(faqih_id));
            }
            problem_input.put("book_id", String.valueOf(book_id));
            problem_input.put("chapter_id", String.valueOf(chapter_id));
            problem_input.put("item_id", String.valueOf(item_id));
            if(!(latest.equals("")))
            {
                problem_input = new HashMap<String, String>();
                problem_input.put("latest", "true");
            }
            problem_input.put("start", String.valueOf(startIndex));
            problem_input.put("count", String.valueOf(count));
            String url = "";
            HTTPServiceHelper book_handler = new HTTPServiceHelper();
            url = ApplicationConstant.problem_list ;//+ "&item_id="+item_id+"&book_id="+book_id+"&chapter_id="+chapter_id;
            String problem_jsonstr = book_handler.performPostCall(url, problem_input);

            ///////// BOOKS //////////////////////////////
            try {
                JSONObject problem_jo_str = new JSONObject(problem_jsonstr);
                JSONObject problem_jo_status = problem_jo_str.getJSONObject("status");
                JSONArray problem_ja_data = problem_jo_status.getJSONArray("data");
                AllCount = problem_jo_status.getInt("time");
//                if(problem_ja_data.length() > 0)
//                    dbh_main.deleteAllBooks();
                for (int i = 0; i < problem_ja_data.length(); i++) {
                    JSONObject problem_jo_data = problem_ja_data.getJSONObject(i);

                    problemVO = new ProblemVO();
                    problemVO.setProblemID(problem_jo_data.getInt("problem_id"));
                    problemVO.setProblemText(problem_jo_data.getString("problem_text"));
                    problemVO.setItemID(problem_jo_data.getInt("item_id"));
                    problemVO.setBookID(problem_jo_data.getInt("book_id"));
                    problemVO.setChapterID(problem_jo_data.getInt("chapter_id"));
                    problemVO.setFaqihID(problem_jo_data.getInt("faqih_id"));
                    problemVO.setUpdate_time(problem_jo_data.getInt("update_time"));

                    al_problemsList.add(problemVO);
                }

            } catch (Exception ex) {}

            return null;
        }

        @Override
        protected void onPostExecute(Void result) {
            super.onPostExecute(result);

            pDialog.dismiss();
            // Assign adapter to ListView
            adapterProblem = new ListAdapter(act, al_problemsList, "problem");
            // Create the Load More... button
            if(startIndex == 0 && AllCount > al_problemsList.size())
            {
                btnLoadExtra = new Button(act);
                btnLoadExtra.setText("المزيد");
                // Adding Load More button to lisview at bottom
                listProblems.addFooterView(btnLoadExtra);
                btnLoadExtra.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View arg0) {
                        // Starting a new async task
                        //new loadMoreListView().execute();
                        ProblemListAsyncTask problemListAsyncTask = new ProblemListAsyncTask();
                        problemListAsyncTask.execute();
                    }
                });
            }

            if(AllCount <= al_problemsList.size())
            {
                listProblems.removeFooterView(btnLoadExtra);
            }


            listProblems.setAdapter(adapterProblem);
//            if(startIndex > 0)
//            {
            listProblems.post(new Runnable() {
                @Override
                public void run() {
                    // Select the last row so it will scroll into view...
                    listProblems.setSelection(adapterProblem.getCount() - count);
                }
            });
            //}
            startIndex += 20;
        }
    }

    /*****************  This function used by adapter ****************/
    public void onItemClick(int position)
    {
        ProblemVO tempValues = (ProblemVO) al_problemsList.get(position);
        Intent i;
        int problem_id = tempValues.getProblemID();
        String problem_text = tempValues.getProblemText();
        i = new Intent(act, Solution.class);
        Bundle extras = new Bundle();
        extras.putInt("problem_id", problem_id);
        extras.putString("problem_text", problem_text);
        i.putExtras(extras);
        startActivity(i);
    }

    /**
     * On selecting action bar icons
     * */
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Take appropriate action for each action item click
        Intent i;
        switch (item.getItemId()) {
            case android.R.id.home:
                onBackPressed();
                return true;
            case R.id.action_home:
                i = new Intent(ProblemsList.this, MainActivity.class);
                startActivity(i);
                return true;
            case R.id.action_settings:
                i = new Intent(ProblemsList.this, SettingsActivity.class);
                startActivity(i);
                return true;
            case R.id.action_search:
                i = new Intent(ProblemsList.this, SearchActivity.class);
                startActivity(i);
                return true;
            case R.id.action_about:
                i = new Intent(ProblemsList.this, AboutActivity.class);
                startActivity(i);
                return true;
            case R.id.action_latest:
                i = new Intent(ProblemsList.this, ProblemsList.class);
                Bundle extras = new Bundle();
                extras.putString("latest", "true");
                i.putExtras(extras);
                startActivity(i);
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.main_menu, menu);
        return super.onCreateOptionsMenu(menu);
    }
}
