package pc.feqhiat;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Spinner;

import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;

import pc.feqhiat.db.DBH_Main;
import pc.feqhiat.model.MainVO;
import pc.feqhiat.model.ProblemVO;
import pc.feqhiat.utils.ApplicationConstant;
import pc.feqhiat.utils.HTTPServiceHelper;
import pc.feqhiat.utils.Utils;

public class SearchActivity extends AppCompatActivity {

    Toolbar toolbar;
    SearchActivity act;
    Spinner spItem, spFaqih, spBook, spChapter;
    EditText etProblem;
    Button btnSend;
    DBH_Main dbhMain;
    int faqihID, bookID, chapterID, item_id = 0;
    MainVO faqih, book, chapter, item;
    String problem = "";
    ArrayList<MainVO> al_item, al_faqih, al_book, al_chapter;
    private Boolean isNetConnected;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_search);

        act = this;

        toolbar = (Toolbar) findViewById(R.id.toolbar);
        toolbar.setTitle("البحث");
        setSupportActionBar(toolbar);

        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setHomeButtonEnabled(true);
        getSupportActionBar().setDisplayShowHomeEnabled(true);

        dbhMain = new DBH_Main(act);

        spItem = (Spinner) findViewById(R.id.sp_item);
        spFaqih = (Spinner) findViewById(R.id.sp_faqih);
        spBook = (Spinner) findViewById(R.id.sp_book);
        spChapter = (Spinner) findViewById(R.id.sp_chapter);

        etProblem = (EditText) findViewById(R.id.et_problem);

        btnSend = (Button) findViewById(R.id.btn_search);

        al_item = new ArrayList<MainVO>();
        al_faqih = new ArrayList<MainVO>();
        al_book = new ArrayList<MainVO>();
        al_chapter = new ArrayList<MainVO>();

        al_faqih = dbhMain.getAllFaqih();
        al_book = dbhMain.getAllBooks();
        al_item = dbhMain.getAllItems();
        al_item.remove(0);// to remove sendEstfta

        final MainVO mv = new MainVO();
        mv.setBookID(0);
        mv.setChapterID(0);
        mv.setFaqihID(0);
        mv.setDesc("الكل");

        //al_faqih.add(0, mv);
        al_book.add(0, mv);
        al_faqih.add(0, mv);

        //////////////// Adapters ///////////////////
        ArrayAdapter<MainVO> itemArrayAdapter = new ArrayAdapter<MainVO>(act, android.R.layout.simple_spinner_item, al_item); //selected item will look like a spinner set from XML
        itemArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spItem.setAdapter(itemArrayAdapter);

        ArrayAdapter<MainVO> faqihArrayAdapter = new ArrayAdapter<MainVO>(act, android.R.layout.simple_spinner_item, al_faqih); //selected item will look like a spinner set from XML
        faqihArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spFaqih.setAdapter(faqihArrayAdapter);

        ArrayAdapter<MainVO> bookArrayAdapter = new ArrayAdapter<MainVO>(act, android.R.layout.simple_spinner_item, al_book); //selected item will look like a spinner set from XML
        bookArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spBook.setAdapter(bookArrayAdapter);

        //// Initiate Listeners ///////////////
        spBook.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener()
        {
            @Override
            public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id)
            {
                MainVO temp = (MainVO) parentView.getItemAtPosition(position);
                al_chapter = dbhMain.getBookChapters(String.valueOf(temp.getBookID()));
                al_chapter.add(0, mv);
                ArrayAdapter<MainVO> chapterArrayAdapter = new ArrayAdapter<MainVO>(act, android.R.layout.simple_spinner_item, al_chapter); //selected item will look like a spinner set from XML
                chapterArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
                spChapter.setAdapter(chapterArrayAdapter);
                //Toast.makeText(act, temp.toString(), Toast.LENGTH_SHORT).show();
            }

            @Override
            public void onNothingSelected(AdapterView<?> parentView)
            {
                //Toast.makeText(topThis, "herf", Toast.LENGTH_LONG).show();
            }
        });


        btnSend.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                if(!(spItem.getSelectedItem() == null)) {
                    item = (MainVO) spItem.getSelectedItem();
                    item_id = item.getItemID();
                }
                if(!(spFaqih.getSelectedItem() == null)) {
                    faqih = (MainVO) spFaqih.getSelectedItem();
                    faqihID = faqih.getFaqihID();
                }
                if(!(spBook.getSelectedItem() == null)) {
                    book = (MainVO) spBook.getSelectedItem();
                    bookID = book.getBookID();
                }
                if(!(spChapter.getSelectedItem() == null)) {
                    chapter = (MainVO) spChapter.getSelectedItem();
                    chapterID = chapter.getChapterID();
                }
                problem = etProblem.getText().toString();

                Intent i;
                //int chapter_id = tempValues.getChapterID();
                i = new Intent(act, ProblemsList.class);
                Bundle extras = new Bundle();
                extras.putInt("item_id", item_id);
                extras.putInt("book_id", bookID);
                extras.putInt("chapter_id", chapterID);
                extras.putInt("faqih_id", faqihID);
                extras.putBoolean("is_search", true);
                extras.putString("search_text", problem);
                i.putExtras(extras);
                startActivity(i);

            }
        });
    }

    /**
     * On selecting action bar icons
     * */
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Take appropriate action for each action item click
        Intent i;
        switch (item.getItemId()) {
            case android.R.id.home:
                onBackPressed();
                return true;
            case R.id.action_home:
                i = new Intent(SearchActivity.this, MainActivity.class);
                startActivity(i);
                return true;
            case R.id.action_settings:
                i = new Intent(SearchActivity.this, SettingsActivity.class);
                startActivity(i);
                return true;
//            case R.id.action_search:
//                i = new Intent(SearchActivity.this, SearchActivity.class);
//                startActivity(i);
//                return true;
            case R.id.action_about:
                i = new Intent(SearchActivity.this, AboutActivity.class);
                startActivity(i);
                return true;
            case R.id.action_latest:
                i = new Intent(SearchActivity.this, ProblemsList.class);
                Bundle extras = new Bundle();
                extras.putString("latest", "true");
                i.putExtras(extras);
                startActivity(i);
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.main_menu, menu);
        return super.onCreateOptionsMenu(menu);
    }

}
