package pc.feqhiat;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.ScrollView;
import android.widget.Spinner;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;

import pc.feqhiat.db.DBH_Main;
import pc.feqhiat.model.MainVO;
import pc.feqhiat.model.ProblemVO;
import pc.feqhiat.utils.ApplicationConstant;
import pc.feqhiat.utils.HTTPServiceHelper;
import pc.feqhiat.utils.Utils;


public class SendFatwaAct extends AppCompatActivity {

    SendFatwaAct act;
    Toolbar toolbar;
    Spinner spFaqih, spBook, spChapter;
    EditText etName, etMobile, etEmail, etProblem;
    Button btnSend;
    ScrollView svMain;
    DBH_Main dbhMain;
    int faqihID, bookID, chapterID = 0;
    MainVO faqih, book, chapter;
    String name, mobile, email, problem;
    ArrayList<MainVO> al_faqih, al_book, al_chapter;
    private Boolean isNetConnected;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_send_fatwa);
        act = this;

        toolbar = (Toolbar) findViewById(R.id.toolbar);
        toolbar.setTitle("إرسال إستفتاء");
        setSupportActionBar(toolbar);

        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setHomeButtonEnabled(true);
        getSupportActionBar().setDisplayShowHomeEnabled(true);

        dbhMain = new DBH_Main(act);

        ///// Initialize the xml comp
        etName = (EditText) findViewById(R.id.et_name);
        etMobile = (EditText) findViewById(R.id.et_mobile);
        etEmail = (EditText) findViewById(R.id.et_email);
        etProblem = (EditText) findViewById(R.id.et_problem);

        spFaqih = (Spinner) findViewById(R.id.sp_faqih);
        spBook = (Spinner) findViewById(R.id.sp_book);
        spChapter = (Spinner) findViewById(R.id.sp_chapter);

        btnSend = (Button) findViewById(R.id.btn_send);
        svMain = (ScrollView) findViewById(R.id.sv_main);

        al_faqih = new ArrayList<MainVO>();
        al_book = new ArrayList<MainVO>();
        al_chapter = new ArrayList<MainVO>();

        al_faqih = dbhMain.getAllFaqih();
        al_book = dbhMain.getAllBooks();

        final MainVO mv = new MainVO();
        mv.setBookID(0);
        mv.setChapterID(0);
        mv.setFaqihID(0);
        mv.setDesc("غير محدد");

        //al_faqih.add(0, mv);
        al_book.add(0, mv);

        //al_chapter = dbhMain.getall;
        //////////////// Adapters ///////////////////
        ArrayAdapter<MainVO> faqihArrayAdapter = new ArrayAdapter<MainVO>(act, android.R.layout.simple_spinner_item, al_faqih); //selected item will look like a spinner set from XML
        faqihArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spFaqih.setAdapter(faqihArrayAdapter);

        ArrayAdapter<MainVO> bookArrayAdapter = new ArrayAdapter<MainVO>(act, android.R.layout.simple_spinner_item, al_book); //selected item will look like a spinner set from XML
        bookArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spBook.setAdapter(bookArrayAdapter);

        //// Initiate Listeners ///////////////
        spBook.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener()
        {
            @Override
            public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id)
            {
                MainVO temp = (MainVO) parentView.getItemAtPosition(position);
                al_chapter = dbhMain.getBookChapters(String.valueOf(temp.getBookID()));
                al_chapter.add(0, mv);
                ArrayAdapter<MainVO> chapterArrayAdapter = new ArrayAdapter<MainVO>(act, android.R.layout.simple_spinner_item, al_chapter); //selected item will look like a spinner set from XML
                chapterArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
                spChapter.setAdapter(chapterArrayAdapter);
                //Toast.makeText(act, temp.toString(), Toast.LENGTH_SHORT).show();
            }

            @Override
            public void onNothingSelected(AdapterView<?> parentView)
            {
                //Toast.makeText(topThis, "herf", Toast.LENGTH_LONG).show();
            }
        });

        etProblem.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                svMain.scrollTo(0, svMain.getBottom());

            }
        });

        etProblem.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

                if(s.toString().trim().length()< 4){
                    btnSend.setEnabled(false);
                } else {
                    btnSend.setEnabled(true);
                }
            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count,
                                          int after) {
                // TODO Auto-generated method stub

            }

            @Override
            public void afterTextChanged(Editable s) {
                // TODO Auto-generated method stub

            }
        });


        btnSend.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                if(!(spFaqih.getSelectedItem() == null)) {
                    faqih = (MainVO) spFaqih.getSelectedItem();
                    faqihID = faqih.getFaqihID();
                }
                if(!(spBook.getSelectedItem() == null)) {
                    book = (MainVO) spBook.getSelectedItem();
                    bookID = book.getBookID();
                }
                if(!(spChapter.getSelectedItem() == null)) {
                    chapter = (MainVO) spChapter.getSelectedItem();
                    chapterID = chapter.getChapterID();
                }
                name = etName.getText().toString();
                mobile = etMobile.getText().toString();
                email = etEmail.getText().toString();
                problem = etProblem.getText().toString();

                isNetConnected = Utils.checkInternetConnection(act);
                if(isNetConnected)
                {
                    SendFatwaAsyncTask sendFatwaAsyncTask = new SendFatwaAsyncTask();
                    sendFatwaAsyncTask.execute();
                }
                else
                {
                    Toast.makeText(act, "أنت غير متصل بالشبكة، يرجى الاتصال بالشبكة ومعاودة المحاولة...", Toast.LENGTH_LONG).show();
                }

            }
        });
    }


    public class SendFatwaAsyncTask extends AsyncTask<Void, Void, Void> {

        Context context;
        private String item_name, item_icon;
        private int item_id, update_time;
        ProgressDialog pDialog;
        ProblemVO problemVO;

        public void Sign_up(Context context) {
            // TODO Auto-generated constructor stub
            this.context = context;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            pDialog = new ProgressDialog(act);
            pDialog.setMessage("الرجاء الانتظار .....");
            pDialog.setCancelable(false);
            pDialog.show();
        }

        @Override
        protected Void doInBackground(Void... arg0) {
            //// Problems /////////
            HashMap<String, String> problem_input = new HashMap<String, String>();
            problem_input.put("name", name);
            problem_input.put("mobile", mobile);
            problem_input.put("email", email);
            problem_input.put("problem", problem);
            problem_input.put("faqih_id", String.valueOf(faqihID));
            problem_input.put("book_id", String.valueOf(bookID));
            problem_input.put("chapter_id", String.valueOf(chapterID));

            HTTPServiceHelper book_handler = new HTTPServiceHelper();
            String problem_jsonstr = book_handler.performPostCall(ApplicationConstant.send_problem, problem_input);

            ///////// BOOKS //////////////////////////////
            try {
                JSONObject problem_jo_str = new JSONObject(problem_jsonstr);
                JSONObject problem_jo_status = problem_jo_str.getJSONObject("status");

            } catch (Exception ex) {}

            return null;
        }

        @Override
        protected void onPostExecute(Void result) {
            super.onPostExecute(result);

            etProblem.setText("");
            Toast.makeText(act, "تم إرسال السؤال وسيتم الرد عليك في أقرب وقت", Toast.LENGTH_LONG);
            pDialog.dismiss();

        }
    }

    /**
     * On selecting action bar icons
     * */
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Take appropriate action for each action item click
        Intent i;
        switch (item.getItemId()) {
            case R.id.action_home:
                i = new Intent(SendFatwaAct.this, MainActivity.class);
                startActivity(i);
                return true;
            case R.id.action_settings:
                i = new Intent(SendFatwaAct.this, SettingsActivity.class);
                startActivity(i);
                return true;
            case R.id.action_search:
                i = new Intent(SendFatwaAct.this, SearchActivity.class);
                startActivity(i);
                return true;
            case R.id.action_about:
                i = new Intent(SendFatwaAct.this, AboutActivity.class);
                startActivity(i);
                return true;
            case R.id.action_latest:
                i = new Intent(SendFatwaAct.this, ProblemsList.class);
                Bundle extras = new Bundle();
                extras.putString("latest", "true");
                i.putExtras(extras);
                startActivity(i);
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.main_menu, menu);
        return super.onCreateOptionsMenu(menu);
    }

}
