package pc.feqhiat;

import android.app.ProgressDialog;
import android.content.ClipData;
import android.content.ClipboardManager;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v4.view.MenuItemCompat;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.ShareActionProvider;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;

import pc.feqhiat.adapter.ListAdapter;
import pc.feqhiat.model.ProblemVO;
import pc.feqhiat.utils.ApplicationConstant;
import pc.feqhiat.utils.HTTPServiceHelper;
import pc.feqhiat.utils.Utils;
import ir.noghteh.JustifiedTextView;

public class Solution extends AppCompatActivity {

    private Solution act;
    private ImageView ivBack, ivFront, ivLineQ , ivLineA;
    private TextView tvCount;//, tvProblem;
    private LinearLayout llSolutions;
    private int problem_id = 0;
    private String problem_text = "";
    private ArrayList<ProblemVO> al_solutions;
    private Boolean isNetConnected;
    private ShareActionProvider mShareActionProvider;
    private JustifiedTextView tvProblem;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_solution);
        act = this;

        ivBack =(ImageView) findViewById(R.id.iv_back);
        ivFront =(ImageView) findViewById(R.id.iv_front);
        tvCount =(TextView) findViewById(R.id.tv_count);
        //tvProblem =(TextView) findViewById(R.id.tv_problem);
        tvProblem = (JustifiedTextView) findViewById(R.id.tv_problem);
        llSolutions =(LinearLayout) findViewById(R.id.ll_solutions);

        Bundle extras = getIntent().getExtras();
        if (extras != null) {
            problem_id = extras.getInt("problem_id");
            problem_text = extras.getString("problem_text");
        }
        al_solutions = new ArrayList<ProblemVO>();
        ivBack.setImageResource(R.drawable.back);
        ivFront.setImageResource(R.drawable.right);
        tvCount.setText("3/20");
        tvProblem.setText(problem_id +": "+ problem_text);
        // Toolbar
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setHomeButtonEnabled(true);
        getSupportActionBar().setDisplayShowHomeEnabled(true);
        /////////////////
        isNetConnected = Utils.checkInternetConnection(act);
        if(isNetConnected)
        {
            SolutionAsyncTask solutionAsyncTask = new SolutionAsyncTask();
            solutionAsyncTask.execute();
        }
        else
        {
        }

        FloatingActionButton fab = (FloatingActionButton) findViewById(R.id.fab);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Snackbar.make(view, "Replace with your own action", Snackbar.LENGTH_LONG)
                        .setAction("Action", null).show();
            }
        });
    }

    /**
     * On selecting action bar icons
     * */
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Take appropriate action for each action item click
        Intent i;
        switch (item.getItemId()) {
            case android.R.id.home:
                onBackPressed();
                return true;
            case R.id.action_copy:
                ClipboardManager clipboard = (ClipboardManager) getSystemService(Context.CLIPBOARD_SERVICE);
                ClipData clip = ClipData.newPlainText("text/plain", createMessage());
                clipboard.setPrimaryClip(clip);
                Toast.makeText(act, "تم نسخ المسألة...", Toast.LENGTH_SHORT).show();
                return true;
            case R.id.action_home:
                i = new Intent(Solution.this, MainActivity.class);
                startActivity(i);
                return true;
            case R.id.action_share:
                createShareIntent();
                return true;
            case R.id.action_settings:
                i = new Intent(Solution.this, SettingsActivity.class);
                startActivity(i);
                return true;
            case R.id.action_search:
                i = new Intent(Solution.this, SearchActivity.class);
                startActivity(i);
                return true;
            case R.id.action_about:
                i = new Intent(Solution.this, AboutActivity.class);
                startActivity(i);
                return true;
            case R.id.action_latest:
                i = new Intent(Solution.this, ProblemsList.class);
                Bundle extras = new Bundle();
                extras.putString("latest", "true");
                i.putExtras(extras);
                startActivity(i);
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menu_problem, menu);
        // Locate MenuItem with ShareActionProvider
        MenuItem item = menu.findItem(R.id.action_share);

        // Fetch and store ShareActionProvider
        mShareActionProvider = (ShareActionProvider) MenuItemCompat.getActionProvider(item);//(android.widget.ShareActionProvider) item.getActionProvider();
        //setShareIntent(createShareIntent());
        return super.onCreateOptionsMenu(menu);
    }

    // Call to update the share intent
    private void setShareIntent(Intent shareIntent) {
        if (mShareActionProvider != null) {
            mShareActionProvider.setShareIntent(shareIntent);
        }
    }

    private void createShareIntent() {
//        String text = "";
//        text += "من برنامج فقهيات المحدثين";
//        text += "\n============\n";
//        text += "السؤال" ;
//        text += "\n";
//        text += problem_text;
//        text += "\n============\n";
//        text += "الجواب";
//        text += "\n";
//
//        for (int i = 0; i < al_solutions.size(); i++){
//            text += "الفقيه: "+al_solutions.get(i).getFaqihName();
//            text += "\n";
//            text+= al_solutions.get(i).getSolutionText();
//            text += "\n------------\n";
//        }
//        text += "\n============\n";
//        text += "عن طريق برنامج فقهيات المحدثين، بإشراف سماحة الشيخ علي الثنيان";
//        text += "\n";
//        text +="لا يجوز التصرف في محتوى الرسالة";
//        text += "\n============\n";
//        text +="لتحميل البرنامج: ";
//        text += "\n";
//        text += "الأندرويد: "+"www.feqhiat.com";
//        text += "\n------------\n";
//        text += "الآيفون: "+"www.feqhiat.com";

        Intent shareIntent = new Intent(Intent.ACTION_SEND);
        shareIntent.setType("text/plain");
        shareIntent.putExtra(Intent.EXTRA_SUBJECT, "مسائل فقهيات المحدثين");
        shareIntent.putExtra(Intent.EXTRA_TEXT, createMessage());
        shareIntent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP);
        startActivity(Intent.createChooser(shareIntent, "الرجاء الاختيار"));
        //return shareIntent;
    }

    private String createMessage()
    {
        //final String appPackageName = getPackageName();
        String text = "";
        text += "تطبيق فقهيات المحدثين";
        text += "\n============\n";
        text += "السؤال" ;
        text += "\n";
        text += problem_text;
        text += "\n============\n";
        text += "الجواب";
        text += "\n";

        for (int i = 0; i < al_solutions.size(); i++){
            text += "الفقيه: "+al_solutions.get(i).getFaqihName();
            text += "\n";
            text+= al_solutions.get(i).getSolutionText();
            text += "\n------------\n";
        }
        text += "\n============\n";
        text += "عن طريق برنامج فقهيات المحدثين، بإشراف سماحة الشيخ علي الثنيان";
        text += "\n";
        text +="لا يجوز التصرف في محتوى الرسالة";
        text += "\n============\n";
        text +="لتحميل البرنامج: ";
        text += "\n";
        text += "الأندرويد: "+"https://goo.gl/2egKUo";// + appPackageName;
//        text += "\n------------\n";
//        text += "الآيفون: "+"www.feqhiat.com";

        return text;
    }

    public class SolutionAsyncTask extends AsyncTask<Void, Void, Void> {

        Context context;
        private String item_name, item_icon;
        private int item_id, update_time;
        ProgressDialog pDialog;
        ProblemVO problemVO;

        public void Sign_up(Context context) {
            // TODO Auto-generated constructor stub
            this.context = context;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            pDialog = new ProgressDialog(act);
            pDialog.setMessage("الرجاء الانتظار .....");
            pDialog.setCancelable(false);
            pDialog.show();
        }

        @Override
        protected Void doInBackground(Void... arg0) {
            //// Problems /////////
            HashMap problem_input = new HashMap<>();
            HTTPServiceHelper book_handler = new HTTPServiceHelper();
            String url = ApplicationConstant.problem_solutions + "&problem_id="+problem_id;
            String problem_jsonstr = book_handler.performPostCall(url, problem_input);

            ///////// Solutions //////////////////////////////
            try {
                JSONObject problem_jo_str = new JSONObject(problem_jsonstr);
                JSONObject problem_jo_status = problem_jo_str.getJSONObject("status");
                JSONArray problem_ja_data = problem_jo_status.getJSONArray("data");
//                if(problem_ja_data.length() > 0)
//                    dbh_main.deleteAllBooks();
                for (int i = 0; i < problem_ja_data.length(); i++) {
                    JSONObject problem_jo_data = problem_ja_data.getJSONObject(i);

                    problemVO = new ProblemVO();
                    problemVO.setProblemID(problem_jo_data.getInt("problem_id"));
                    problemVO.setFaqihID(problem_jo_data.getInt("faqih_id"));
                    problemVO.setSolutionText(problem_jo_data.getString("solution_text"));
                    problemVO.setFaqihName(problem_jo_data.getString("faqih_name"));
                    problemVO.setUpdate_time(problem_jo_data.getInt("update_time"));

                    al_solutions.add(problemVO);
                }

            } catch (Exception ex) {}

            return null;
        }

        @Override
        protected void onPostExecute(Void result) {
            super.onPostExecute(result);

            View singleSolution;
            TextView tvFaqih;
            JustifiedTextView tvSolution;
            pDialog.dismiss();
            for (int i = 0; i < al_solutions.size(); i++){
                singleSolution = getLayoutInflater().inflate(R.layout.single_solution, null);
                tvFaqih = (TextView) singleSolution.findViewById(R.id.tv_faqih);
                tvFaqih.setText("الفقيه: "+al_solutions.get(i).getFaqihName());
                tvSolution = (JustifiedTextView) singleSolution.findViewById(R.id.tv_solution);
                tvSolution.setText(al_solutions.get(i).getSolutionText());

                llSolutions.addView(singleSolution);
            }

        }
    }

//    /*****************  This function used by adapter ****************/
//    public void onItemClick(int position)
//    {
//        ProblemVO tempValues = (ProblemVO) al_problemsList.get(position);
//        Intent i;
//        int problem_id = tempValues.getProblemID();
//        i = new Intent(act, Solution.class);
//        Bundle extras = new Bundle();
//        extras.putInt("problem_id", problem_id);
//        i.putExtras(extras);
//        startActivity(i);
//    }

}
