package pc.feqhiat.adapter;


import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.ArrayList;
import java.util.List;

import pc.feqhiat.model.MainVO;
import pc.feqhiat.db.DBH_Main;
import pc.feqhiat.R;
import pc.feqhiat.model.ProblemVO;

public class ItemAdapter extends BaseAdapter{
    private Context mContext;
    LayoutInflater inflater;
    String type;
    private List<MainVO> items;

    public ItemAdapter(Context c, String type, List<MainVO> l_item) {
        mContext = c;
        this.type = type;
        inflater = (LayoutInflater) mContext
                .getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        items = l_item;//new ArrayList<MainVO>();
//        DBH_Main dbh_mainMenu = new DBH_Main(mContext);
//        if(type.equals("item"))
//            items = dbh_mainMenu.getAllItems();
//        else
//            items = dbh_mainMenu.getAllBooks();
    }

    public int getCount() {
        return items.size();
    }

    public Object getItem(int position) {
        return position;
    }

    public long getItemId(int position) {
        return position;
    }

    /********* Create a holder Class to contain inflated xml file elements *********/
    public static class ViewHolder{

        public TextView text, tvCount;
        public ImageView image;

    }

    // create a new ImageView for each item referenced by the Adapter
    public View getView(int position, View convertView, ViewGroup parent) {
        View vi = convertView;
        MainVO subItemDB;
        ViewHolder holder;

        if(convertView==null){

            /****** Inflate main_item.xml file for each item ( Defined below ) *******/
            vi = inflater.inflate(R.layout.main_item, null);

            /****** View Holder Object to contain general_row.xml file elements ******/

            holder = new ViewHolder();
            holder.text = (TextView) vi.findViewById(R.id.tv_itmName);
            holder.tvCount = (TextView) vi.findViewById(R.id.tv_count);
            holder.image=(ImageView) vi.findViewById(R.id.iv_item);

            /************  Set holder with LayoutInflater ************/
            vi.setTag( holder );
        }
        else
            holder=(ViewHolder)vi.getTag();

        if(items.size()<=0)
        {
            holder.text.setText("لا يوجد بيانات");

        }
        else
        {
            /***** Get each Model object from Arraylist ********/
            subItemDB=null;
            subItemDB = (MainVO) items.get( position );
            /************  Set Model values in Holder elements ***********/
            holder.text.setText(subItemDB.getDesc());
            if(subItemDB.getCount() == 0)
                holder.tvCount.setVisibility(View.GONE);
            else
            {
                holder.tvCount.setText(String.valueOf(subItemDB.getCount()));
                holder.tvCount.setVisibility(View.VISIBLE);
            }
            //holder.image.setImageResource(R.drawable.book_icon002);
        }
        return vi;
    }

}