package pc.feqhiat.adapter;

import android.app.Activity;
import android.content.DialogInterface;
import android.support.v7.app.AppCompatActivity;
import android.content.Context;
import android.content.res.Resources;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.ArrayList;
import java.util.List;

import pc.feqhiat.BookMenu;
import pc.feqhiat.ChapterMenu;
import pc.feqhiat.NewsListActivity;
import pc.feqhiat.ProblemsList;
import pc.feqhiat.R;
import pc.feqhiat.model.MainVO;
import pc.feqhiat.model.ProblemVO;

/********* Adapter class extends with BaseAdapter and implements with OnClickListener ************/
public class ListAdapter extends BaseAdapter implements OnClickListener{

    /*********** Declare Used Variables *********/
    private Activity activity;
    private List data;
    private static LayoutInflater inflater=null;
    public Resources res;
    private String act_name;
    MainVO tempValues=null;
    ProblemVO problemVO=null;
    int i=0;

    /*************  CustomAdapter Constructor *****************/
    public ListAdapter(Activity a, ArrayList d, String actName) {//,Resources resLocal

        /********** Take passed values **********/
        activity = a;
        data=d;
        act_name = actName;
        //res = resLocal;

        /***********  Layout inflator to call external xml layout () ***********/
        inflater = ( LayoutInflater )activity.
                getSystemService(Context.LAYOUT_INFLATER_SERVICE);

    }

    /******** What is the size of Passed Arraylist Size ************/
    public int getCount() {

        if(data.size()<=0)
            return 1;
        return data.size();
    }

    public Object getItem(int position) {
        return position;
    }

    public long getItemId(int position) {
        return position;
    }

    /********* Create a holder Class to contain inflated xml file elements *********/
    public static class ViewHolder{

        public TextView text, tvCount;
//        public TextView text1;
//        public TextView textWide;
//        public ImageView image;

    }

    /****** Depends upon data size called for each row , Create each ListView row *****/
    public View getView(int position, View convertView, ViewGroup parent) {

        View vi = convertView;
        ViewHolder holder;
        int seq = 0;

        if(convertView==null){

            /****** Inflate general_row.xml file for each row ( Defined below ) *******/
            vi = inflater.inflate(R.layout.general_row, null);

            /****** View Holder Object to contain general_row.xml file elements ******/

            holder = new ViewHolder();
            holder.text = (TextView) vi.findViewById(R.id.text);
            holder.tvCount=(TextView)vi.findViewById(R.id.tv_countC);
            //holder.image=(ImageView)vi.findViewById(R.id.image);

            /************  Set holder with LayoutInflater ************/
            vi.setTag( holder );
        }
        else
            holder=(ViewHolder)vi.getTag();

        if(data.size()<=0)
        {
            holder.text.setText("لا يوجد بيانات");

        }
        else
        {
            /***** Get each Model object from Arraylist ********/
            if(act_name.equals("problem") || act_name.equals("news"))
            {
                problemVO=null;
                problemVO = (ProblemVO) data.get( position );
            }
            else
            {
                tempValues=null;
                tempValues = (MainVO) data.get( position );
            }

            /************  Set Model values in Holder elements ***********/
            if(act_name.equals("problem"))
            {
                seq = position+1;
                holder.text.setText(seq +": " + problemVO.getProblemText());
            }
            else if(act_name.equals("news"))
            {
                holder.text.setText(problemVO.getNewsTitle());
            }
            else {
                holder.text.setText( tempValues.getDesc());
                if(tempValues.getCount() == 0)
                    holder.tvCount.setVisibility(View.GONE);
                else
                {
                    holder.tvCount.setText(String.valueOf(tempValues.getCount()));
                    holder.tvCount.setVisibility(View.VISIBLE);
                }
            }
            /******** Set Item Click Listner for LayoutInflater for each row *******/

            vi.setOnClickListener(new OnItemClickListener( position ));
        }
        return vi;
    }

    @Override
    public void onClick(View v) {
        Log.v("CustomAdapter", "=====Row button clicked=====");
    }

    /********* Called when Item click in ListView ************/
    private class OnItemClickListener  implements OnClickListener{
        private int mPosition;

        OnItemClickListener(int position){
            mPosition = position;
        }

        @Override
        public void onClick(View arg0) {

            if(act_name.equals("chapter"))
            {
                ChapterMenu sct = (ChapterMenu)activity;
                sct.onItemClick(mPosition);
            }
            else if(act_name.equals("problem"))
            {
                ProblemsList sct = (ProblemsList)activity;
                sct.onItemClick(mPosition);
            }
            else if(act_name.equals("news"))
            {
                NewsListActivity sct = (NewsListActivity)activity;
                sct.onItemClick(mPosition);
            }

            /****  Call  onItemClick Method inside CustomListViewAndroidExample Class ( See Below )****/


        }
    }
}